POJ2331:Water pipe(IDA*)

Description

The Eastowner city is perpetually haunted with water supply shortages, so in order to remedy this problem a new water-pipe has been built. Builders started the pipe from both ends simultaneously, and after some hard work both halves were connected. Well, almost. First half of pipe ended at a point (x1, y1), and the second half -- at (x2, y2). Unfortunately only few pipe segments of different length were left. Moreover, due to the peculiarities of local technology the pipes can only be put in either north-south or east-west direction, and be connected to form a straight line or 90 degree turn. You program must, given L1, L2, ... Lk -- lengths of pipe segments available and C1, C2, ... Ck -- number of segments of each length, construct a water pipe connecting given points, or declare that it is impossible. Program must output the minimum required number of segments. 

Constraints 
1 <= k <= 4, 1 <= xi, yi, Li <= 1000, 1 <= Ci <= 10

Input

Input contains integers x1 y1 x2 y2 k followed by 2k integers L1 L2 ... Lk C1 C2 ... Ck

Output

Output must contain a single integer -- the number of required segments, or −1 if the connection is impossible.

Sample Input

20 10 60 50 2 70 30 2 2

Sample Output

4
 
思路:先用bfs将x轴和y轴都搜一次,得到所有的h值,然后再dfs找到答案
 
 
#include <stdio.h>
#include <string.h>
#include <queue>
#include <algorithm>
using namespace std;

int sx,sy,ex,ey,n,hx[1005],hy[1005],sum,ans;
struct node
{
    int l,c;
} a[10];

void bfs(int *h,int pos)
{
    int i;
    queue<int> Q;
    h[pos] = 0;
    Q.push(pos);
    while(!Q.empty())
    {
        pos = Q.front();
        Q.pop();
        for(i = 0; i<n; i++)
        {

            if(pos-a[i].l>=1 && h[pos-a[i].l]==-1)
            {
                h[pos-a[i].l] = h[pos]+1;
                Q.push(pos-a[i].l);
            }
            if(pos+a[i].l<=1000 && h[pos+a[i].l]==-1)
            {
                h[pos+a[i].l] = h[pos]+1;
                Q.push(pos+a[i].l);
            }
        }
    }
}

int IDA(node *a,int x,int deep,int kind)
{
    int i,hv;
    node tem[10];
    hv = kind?hy[x]:hx[x];
    if(hv == -1 || hv+deep>ans)
        return 0;
    if(hv == 0)
    {
        if(kind == 0) return IDA(a,sy,deep,1);
        else return 1;
    }
    for(i = 0; i<n; i++)
        tem[i] = a[i];
    for(i = 0; i<n; i++)
    {
        if(tem[i].c<=0)
            continue;
        tem[i].c--;
        if(x-tem[i].l>=1) if(IDA(tem,x-tem[i].l,deep+1,kind)) return 1;
        if(x+tem[i].l<=1000) if(IDA(tem,x+tem[i].l,deep+1,kind)) return 1;
        tem[i].c++;
    }
    return 0;
}

void solve()
{
    memset(hx,-1,sizeof(hx));
    memset(hy,-1,sizeof(hy));
    bfs(hx,ex);
    bfs(hy,ey);
    for(ans = 1; ans<=sum; ans++)
        if(IDA(a,sx,0,0))
            break;
    if(ans<=sum)
        printf("%d\n",ans);
    else
        printf("-1\n");
}

int main()
{
    int i,j;
    sum = 0;
    scanf("%d%d%d%d%d",&sx,&sy,&ex,&ey,&n);
    for(i = 0; i<n; i++)
        scanf("%d",&a[i].l);
    for(i = 0; i<n; i++)
    {
        scanf("%d",&a[i].c);
        sum+=a[i].c;
    }
    if(sx == ex && sy == ey)
        printf("0\n");
    else
        solve();

    return 0;
}



                
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
这是一道比较经典的计数问题。题目描述如下: 给定一个 $n \times n$ 的网格图,其中一些格子被标记为障碍。一个连通块是指一些被标记为障碍的格子的集合,满足这些格子在网格图中连通。一个格子是连通的当且仅当它与另一个被标记为障碍的格子在网格图中有公共边。 现在,你需要计算在这个网格图中,有多少个不同的连通块,满足这个连通块的大小(即包含的格子数)恰好为 $k$。 这是一道比较经典的计数问题,一般可以通过计算生成函数的方法来解决。具体来说,我们可以定义一个生成函数 $F(x)$,其中 $[x^k]F(x)$ 表示大小为 $k$ 的连通块的个数。那么,我们可以考虑如何计算这个生成函数。 对于一个大小为 $k$ 的连通块,我们可以考虑它的形状。具体来说,我们可以考虑以该连通块的最左边、最上边的格子为起点,从上到下、从左到右遍历该连通块,把每个格子在该连通块中的相对位置记录下来。由于该连通块的大小为 $k$,因此这些相对位置一定是 $(x,y) \in [0,n-1]^2$ 中的 $k$ 个不同点。 现在,我们需要考虑如何计算这些点对应的连通块是否合法。具体来说,我们可以考虑从左到右、从上到下依次处理这些点,对于每个点 $(x,y)$,我们需要考虑它是否能够与左边的点和上边的点连通。具体来说,如果 $(x-1,y)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们就是连通的;同样,如果 $(x,y-1)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们也是连通的。如果 $(x,y)$ 与左边和上边的点都不连通,那么说明这个点不属于该连通块。 考虑到每个点最多只有两个方向需要检查,因此时间复杂度为 $O(n^2 k)$。不过,我们可以使用类似于矩阵乘法的思想,将这个过程优化到 $O(k^3)$ 的时间复杂度。 具体来说,我们可以设 $f_{i,j,k}$ 表示状态 $(i,j)$ 所代表的点在连通块中,且连通块的大小为 $k$ 的方案数。显然,对于一个合法的 $(i,j,k)$,我们可以考虑 $(i-1,j,k-1)$ 和 $(i,j-1,k-1)$ 这两个状态,然后把点 $(i,j)$ 加入到它们所代表的连通块中。因此,我们可以设计一个 $O(k^3)$ 的 DP 状态转移,计算 $f_{i,j,k}$。 具体来说,我们可以考虑枚举连通块所包含的最右边和最下边的格子的坐标 $(x,y)$,然后计算 $f_{x,y,k}$。对于一个合法的 $(x,y,k)$,我们可以考虑将 $(x,y)$ 所代表的点加入到 $(x-1,y,k-1)$ 和 $(x,y-1,k-1)$ 所代表的连通块中。不过,这里需要注意一个细节:如果 $(x-1,y)$ 和 $(x,y)$ 在网格图中没有相邻边,那么它们不能算作连通的。因此,我们需要特判这个情况。 最终,$f_{n,n,k}$ 就是大小为 $k$ 的连通块的个数,时间复杂度为 $O(n^2 k + k^3)$。 参考代码:
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值